Index: uspace/drv/vhc/hc.c
===================================================================
--- uspace/drv/vhc/hc.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hc.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -34,5 +34,4 @@
  */
 
-#include <ipc/ipc.h>
 #include <adt/list.h>
 #include <bool.h>
@@ -90,12 +89,12 @@
  */
 static void process_transaction_with_outcome(transaction_t * transaction,
-    usb_transaction_outcome_t outcome)
-{
-	dprintf(3, "transaction " TRANSACTION_FORMAT " done, outcome: %s",
+    int outcome)
+{
+	usb_log_debug2("Transaction " TRANSACTION_FORMAT " done: %s.\n",
 	    TRANSACTION_PRINTF(*transaction),
-	    usb_str_transaction_outcome(outcome));
-	
-	transaction->callback(transaction->buffer, transaction->len, outcome,
-	    transaction->callback_arg);
+	    str_error(outcome));
+	
+	transaction->callback(transaction->buffer, transaction->actual_len,
+	    outcome, transaction->callback_arg);
 }
 
@@ -108,5 +107,5 @@
 	static unsigned int seed = 4573;
 	
-	printf("%s: transaction processor ready.\n", NAME);
+	usb_log_info("Transaction processor ready.\n");
 	
 	while (true) {
@@ -125,12 +124,8 @@
 		list_remove(first_transaction_link);
 		
-
-		dprintf(0, "about to process " TRANSACTION_FORMAT " [%s]",
+		usb_log_debug("Processing " TRANSACTION_FORMAT " [%s].\n",
 		    TRANSACTION_PRINTF(*transaction), ports);
 
-		dprintf(3, "processing transaction " TRANSACTION_FORMAT "",
-		    TRANSACTION_PRINTF(*transaction));
-		
-		usb_transaction_outcome_t outcome;
+		int outcome;
 		outcome = virtdev_send_to_all(transaction);
 		
@@ -148,5 +143,5 @@
 	fid_t fid = fibril_create(hc_manager_fibril, NULL);
 	if (fid == 0) {
-		printf(NAME ": failed to start HC manager fibril\n");
+		usb_log_fatal("Failed to start HC manager fibril.\n");
 		return;
 	}
@@ -169,11 +164,16 @@
 	transaction->buffer = buffer;
 	transaction->len = len;
+	transaction->actual_len = len;
 	transaction->callback = callback;
 	transaction->callback_arg = arg;
-	
-	dprintf(3, "creating transaction " TRANSACTION_FORMAT,
+
+	return transaction;
+}
+
+static void hc_add_transaction(transaction_t *transaction)
+{
+	usb_log_debug("Adding transaction " TRANSACTION_FORMAT ".\n",
 	    TRANSACTION_PRINTF(*transaction));
-	
-	return transaction;
+	list_append(&transaction->link, &transaction_list);
 }
 
@@ -189,5 +189,5 @@
 	    target, transfer_type,
 	    buffer, len, callback, arg);
-	list_append(&transaction->link, &transaction_list);
+	hc_add_transaction(transaction);
 }
 
@@ -202,5 +202,5 @@
 	    target, transfer_type,
 	    buffer, len, callback, arg);
-	list_append(&transaction->link, &transaction_list);
+	hc_add_transaction(transaction);
 }
 
Index: uspace/drv/vhc/hc.h
===================================================================
--- uspace/drv/vhc/hc.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hc.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -47,5 +47,5 @@
  */
 typedef void (*hc_transaction_done_callback_t)(void *buffer, size_t size,
-    usb_transaction_outcome_t outcome, void *arg);
+    int outcome, void *arg);
 
 /** Pending transaction details. */
@@ -65,4 +65,6 @@
 	/** Transaction data length. */
 	size_t len;
+	/** Data length actually transfered. */
+	size_t actual_len;
 	/** Callback after transaction is done. */
 	hc_transaction_done_callback_t callback;
Index: uspace/drv/vhc/hcd.c
===================================================================
--- uspace/drv/vhc/hcd.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hcd.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */ 
@@ -35,5 +35,4 @@
 
 #include <devmap.h>
-#include <ipc/ipc.h>
 #include <async.h>
 #include <unistd.h>
@@ -43,7 +42,8 @@
 #include <errno.h>
 #include <str_error.h>
-#include <driver.h>
+#include <ddf/driver.h>
 
 #include <usb/usb.h>
+#include <usb/ddfiface.h>
 #include <usb_iface.h>
 #include "vhcd.h"
@@ -53,26 +53,16 @@
 #include "conn.h"
 
-static int usb_iface_get_hc_handle(device_t *dev, devman_handle_t *handle)
-{
-	/* This shall be called only for VHC device. */
-	assert(dev->parent == NULL);
-
-	*handle = dev->handle;
-	return EOK;
-}
-
-static usb_iface_t hc_usb_iface = {
-	.get_hc_handle = usb_iface_get_hc_handle
-};
-
-static device_ops_t vhc_ops = {
+static ddf_dev_ops_t vhc_ops = {
 	.interfaces[USBHC_DEV_IFACE] = &vhc_iface,
-	.interfaces[USB_DEV_IFACE] = &hc_usb_iface,
+	.interfaces[USB_DEV_IFACE] = &vhc_usb_iface,
+	.close = on_client_close,
 	.default_handler = default_connection_handler
 };
 
-static int vhc_count = 0;
-static int vhc_add_device(device_t *dev)
+static int vhc_add_device(ddf_dev_t *dev)
 {
+	static int vhc_count = 0;
+	int rc;
+
 	/*
 	 * Currently, we know how to simulate only single HC.
@@ -82,16 +72,32 @@
 	}
 
-	vhc_count++;
+	/*
+	 * Create exposed function representing the host controller
+	 * itself.
+	 */
+	ddf_fun_t *hc = ddf_fun_create(dev, fun_exposed, "hc");
+	if (hc == NULL) {
+		usb_log_fatal("Failed to create device function.\n");
+		return ENOMEM;
+	}
 
-	dev->ops = &vhc_ops;
+	hc->ops = &vhc_ops;
 
-	devman_add_device_to_class(dev->handle, "usbhc");
+	rc = ddf_fun_bind(hc);
+	if (rc != EOK) {
+		usb_log_fatal("Failed to bind HC function: %s.\n",
+		    str_error(rc));
+		return rc;
+	}
+
+	ddf_fun_add_to_class(hc, "usbhc");
 
 	/*
 	 * Initialize our hub and announce its presence.
 	 */
-	virtual_hub_device_init(dev);
+	virtual_hub_device_init(hc);
 
-	printf("%s: virtual USB host controller ready.\n", NAME);
+	usb_log_info("Virtual USB host controller ready (dev %zu, hc %zu).\n",
+	    (size_t) dev->handle, (size_t) hc->handle);
 
 	return EOK;
@@ -114,7 +120,7 @@
 	 * in devman output.
 	 */
-	sleep(5);
+	//sleep(5);
 
-	usb_dprintf_enable(NAME, 0);
+	usb_log_enable(USB_LOG_LEVEL_DEBUG, NAME);
 
 	printf(NAME ": virtual USB host controller driver.\n");
@@ -133,5 +139,5 @@
 	 * We are also a driver within devman framework.
 	 */
-	return driver_main(&vhc_driver);
+	return ddf_driver_main(&vhc_driver);
 }
 
Index: uspace/drv/vhc/hub.c
===================================================================
--- uspace/drv/vhc/hub.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -39,16 +39,22 @@
 #include <str_error.h>
 #include <stdlib.h>
-#include <driver.h>
-#include <usb/usbdrv.h>
+#include <ddf/driver.h>
+#include <devman.h>
+#include <usb/hub.h>
+#include <usb/recognise.h>
 
 #include "hub.h"
 #include "hub/virthub.h"
 #include "vhcd.h"
+#include "conn.h"
 
 usbvirt_device_t virtual_hub_device;
+static ddf_dev_ops_t rh_ops = {
+	.interfaces[USB_DEV_IFACE] = &rh_usb_iface,
+};
 
 static int hub_register_in_devman_fibril(void *arg);
 
-void virtual_hub_device_init(device_t *hc_dev)
+void virtual_hub_device_init(ddf_fun_t *hc_dev)
 {
 	virthub_init(&virtual_hub_device);
@@ -63,9 +69,14 @@
 	    = fibril_create(hub_register_in_devman_fibril, hc_dev);
 	if (root_hub_registration == 0) {
-		printf(NAME ": failed to register root hub\n");
+		usb_log_fatal("Failed to create hub registration fibril.\n");
 		return;
 	}
 
 	fibril_add_ready(root_hub_registration);
+}
+
+static int pretend_port_rest(int unused, void *unused2)
+{
+	return EOK;
 }
 
@@ -77,24 +88,40 @@
 int hub_register_in_devman_fibril(void *arg)
 {
-	device_t *hc_dev = (device_t *) arg;
+	ddf_fun_t *hc_dev = (ddf_fun_t *) arg;
 
-	int hc = usb_drv_hc_connect(hc_dev, hc_dev->handle, IPC_FLAG_BLOCKING);
-	if (hc < 0) {
-		printf(NAME ": failed to register root hub\n");
-		return hc;
+	/*
+	 * Wait until parent device is properly initialized.
+	 */
+	int phone;
+	do {
+		phone = devman_device_connect(hc_dev->handle, 0);
+	} while (phone < 0);
+	async_hangup(phone);
+
+	int rc;
+
+	usb_hc_connection_t hc_conn;
+	rc = usb_hc_connection_initialize(&hc_conn, hc_dev->handle);
+	assert(rc == EOK);
+
+	rc = usb_hc_connection_open(&hc_conn);
+	assert(rc == EOK);
+
+	ddf_fun_t *hub_dev;
+	rc = usb_hc_new_device_wrapper(hc_dev->dev, &hc_conn,
+	    USB_SPEED_FULL,
+	    pretend_port_rest, 0, NULL,
+	    NULL, NULL, &rh_ops, hc_dev, &hub_dev);
+	if (rc != EOK) {
+		usb_log_fatal("Failed to create root hub: %s.\n",
+		    str_error(rc));
 	}
 
-	usb_drv_reserve_default_address(hc);
+	usb_hc_connection_close(&hc_conn);
 
-	usb_address_t hub_address = usb_drv_request_address(hc);
-	usb_drv_req_set_address(hc, USB_ADDRESS_DEFAULT, hub_address);
+	usb_log_info("Created root hub function (handle %zu).\n",
+	    (size_t) hub_dev->handle);
 
-	usb_drv_release_default_address(hc);
-
-	devman_handle_t hub_handle;
-	usb_drv_register_child_in_devman(hc, hc_dev, hub_address, &hub_handle);
-	usb_drv_bind_address(hc, hub_address, hub_handle);
-
-	return EOK;
+	return 0;
 }
 	
Index: uspace/drv/vhc/hub.h
===================================================================
--- uspace/drv/vhc/hub.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -37,5 +37,5 @@
 
 #include <usbvirt/device.h>
-#include <driver.h>
+#include <ddf/driver.h>
 
 #include "devices.h"
@@ -45,5 +45,5 @@
 extern usbvirt_device_t virtual_hub_device;
 
-void virtual_hub_device_init(device_t *);
+void virtual_hub_device_init(ddf_fun_t *);
 
 #endif
Index: uspace/drv/vhc/hub/hub.c
===================================================================
--- uspace/drv/vhc/hub/hub.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub/hub.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -38,7 +38,7 @@
 #include <errno.h>
 #include <str_error.h>
+#include <assert.h>
 #include <stdlib.h>
-#include <driver.h>
-#include <usb/usbdrv.h>
+#include <ddf/driver.h>
 
 #include "hub.h"
@@ -155,4 +155,26 @@
 }
 
+/** Disconnects a device from a hub.
+ *
+ * @param hub Hub the device was connected to.
+ * @param device Device to be disconnected.
+ * @return Error code.
+ */
+int hub_disconnect_device(hub_t *hub, void *device)
+{
+	size_t index = hub_find_device(hub, device);
+	if (index == (size_t) -1) {
+		return ENOENT;
+	}
+
+	hub_port_t *port = &hub->ports[index];
+
+	port->connected_device = NULL;
+	port->state = HUB_PORT_STATE_DISCONNECTED;
+	set_port_status_change(port, HUB_STATUS_C_PORT_CONNECTION);
+
+	return EOK;
+}
+
 /** Find port device is connected to.
  *
@@ -173,5 +195,5 @@
 	}
 
-	return 0;
+	return -1;
 }
 
Index: uspace/drv/vhc/hub/hub.h
===================================================================
--- uspace/drv/vhc/hub/hub.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub/hub.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -38,5 +38,7 @@
 #include <fibril_synch.h>
 
+#ifndef HUB_PORT_COUNT
 #define HUB_PORT_COUNT 2
+#endif
 #define BITS2BYTES(bits) (bits ? ((((bits)-1)>>3)+1) : 0)
 
@@ -94,4 +96,5 @@
 void hub_init(hub_t *);
 size_t hub_connect_device(hub_t *, void *);
+int hub_disconnect_device(hub_t *, void *);
 size_t hub_find_device(hub_t *, void *);
 void hub_acquire(hub_t *);
Index: uspace/drv/vhc/hub/virthub.c
===================================================================
--- uspace/drv/vhc/hub/virthub.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub/virthub.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -39,7 +39,7 @@
 #include <errno.h>
 #include <str_error.h>
+#include <assert.h>
 #include <stdlib.h>
-#include <driver.h>
-#include <usb/usbdrv.h>
+#include <ddf/driver.h>
 
 #include "virthub.h"
@@ -164,7 +164,13 @@
 	dev->device_data = hub;
 
-	usbvirt_connect_local(dev);
-
-	return EOK;
+	int rc;
+#ifdef STANDALONE_HUB
+	dev->name = "hub";
+	rc = usbvirt_connect(dev);
+#else
+	rc = usbvirt_connect_local(dev);
+#endif
+
+	return rc;
 }
 
@@ -203,5 +209,5 @@
 
 	hub_acquire(hub);
-	/* TODO: implement. */
+	hub_disconnect_device(hub, conn);
 	hub_release(hub);
 
Index: uspace/drv/vhc/hub/virthub.h
===================================================================
--- uspace/drv/vhc/hub/virthub.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub/virthub.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -37,6 +37,11 @@
 
 #include <usbvirt/device.h>
+#include "hub.h"
+
+#ifdef STANDALONE_HUB
+#define virtdev_connection_t int
+#else
 #include "../devices.h"
-#include "hub.h"
+#endif
 
 /** Endpoint number for status change pipe. */
Index: uspace/drv/vhc/hub/virthubops.c
===================================================================
--- uspace/drv/vhc/hub/virthubops.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/hub/virthubops.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
Index: uspace/drv/vhc/vhcd.h
===================================================================
--- uspace/drv/vhc/vhcd.h	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/drv/vhc/vhcd.h	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup usb
+/** @addtogroup drvusbvhc
  * @{
  */
@@ -45,7 +45,7 @@
 #define DEVMAP_PATH_DEV NAMESPACE "/" NAME_DEV
 
-#define dprintf(level, format, ...) \
-	usb_dprintf(NAME, (level), format "\n", ##__VA_ARGS__)
-void dprintf_inval_call(int, ipc_call_t, sysarg_t);
+//#define dprintf(level, format, ...)
+//	usb_dprintf(NAME, (level), format "\n", ##__VA_ARGS__)
+//void dprintf_inval_call(int, ipc_call_t, sysarg_t);
 
 #endif
Index: uspace/lib/block/libblock.c
===================================================================
--- uspace/lib/block/libblock.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/block/libblock.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -44,5 +44,4 @@
 #include <sys/mman.h>
 #include <async.h>
-#include <ipc/ipc.h>
 #include <as.h>
 #include <assert.h>
@@ -177,5 +176,5 @@
 	if (rc != EOK) {
 	    	munmap(comm_area, comm_size);
-		ipc_hangup(dev_phone);
+		async_hangup(dev_phone);
 		return rc;
 	}
@@ -183,5 +182,5 @@
 	if (get_block_size(dev_phone, &bsize) != EOK) {
 		munmap(comm_area, comm_size);
-		ipc_hangup(dev_phone);
+		async_hangup(dev_phone);
 		return rc;
 	}
@@ -190,5 +189,5 @@
 	if (rc != EOK) {
 		munmap(comm_area, comm_size);
-		ipc_hangup(dev_phone);
+		async_hangup(dev_phone);
 		return rc;
 	}
@@ -211,5 +210,5 @@
 
 	munmap(devcon->comm_area, devcon->comm_size);
-	ipc_hangup(devcon->dev_phone);
+	async_hangup(devcon->dev_phone);
 
 	free(devcon);	
@@ -295,6 +294,8 @@
 
 	/* Allow 1:1 or small-to-large block size translation */
-	if (cache->lblock_size % devcon->pblock_size != 0)
+	if (cache->lblock_size % devcon->pblock_size != 0) {
+		free(cache);
 		return ENOTSUP;
+	}
 
 	cache->blocks_cluster = cache->lblock_size / devcon->pblock_size;
@@ -437,4 +438,5 @@
 			if (!b->data) {
 				free(b);
+				b = NULL;
 				goto recycle;
 			}
@@ -564,4 +566,5 @@
 	assert(devcon);
 	assert(devcon->cache);
+	assert(block->refcnt >= 1);
 
 	cache = devcon->cache;
@@ -623,6 +626,7 @@
 			unsigned long key = block->lba;
 			hash_table_remove(&cache->block_hash, &key, 1);
+			fibril_mutex_unlock(&block->lock);
+			free(block->data);
 			free(block);
-			free(block->data);
 			cache->blocks_cached--;
 			fibril_mutex_unlock(&cache->lock);
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/Makefile	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -83,4 +83,5 @@
 	generic/io/console.c \
 	generic/io/screenbuffer.c \
+	generic/ipc/ns.c \
 	generic/malloc.c \
 	generic/sysinfo.c \
@@ -90,11 +91,10 @@
 	generic/loader.c \
 	generic/getopt.c \
-	generic/adt/list.o \
-	generic/adt/hash_table.o \
+	generic/adt/list.c \
+	generic/adt/hash_table.c \
 	generic/adt/dynamic_fifo.c \
 	generic/adt/measured_strings.c \
 	generic/adt/char_map.c \
 	generic/time.c \
-	generic/err.c \
 	generic/stdlib.c \
 	generic/mman.c \
Index: uspace/lib/c/arch/abs32le/_link.ld.in
===================================================================
--- uspace/lib/c/arch/abs32le/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/abs32le/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -44,8 +44,4 @@
 	} :data
 	
-	. = ALIGN(0x1000);
-	
-	_heap = .;
-	
 	/DISCARD/ : {
 		*(*);
Index: uspace/lib/c/arch/abs32le/src/entry.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/entry.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/abs32le/src/entry.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -30,12 +30,11 @@
  */
 
-#include <libc.h>
 #include <unistd.h>
 #include <libarch/entry.h>
+#include "../../../generic/private/libc.h"
 
 void __entry(void)
 {
 	__main(NULL);
-	__exit();
 }
 
Index: uspace/lib/c/arch/abs32le/src/thread_entry.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/thread_entry.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/abs32le/src/thread_entry.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -31,5 +31,5 @@
 
 #include <unistd.h>
-#include <thread.h>
+#include "../../../generic/private/thread.h"
 
 void __thread_entry(void)
Index: uspace/lib/c/arch/amd64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/amd64/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/amd64/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -5,4 +5,5 @@
 	text PT_LOAD FLAGS(5);
 	data PT_LOAD FLAGS(6);
+	debug PT_NOTE;
 }
 
@@ -13,14 +14,16 @@
 		*(.init);
 	} :text
+	
 	.text : {
 		*(.text);
 		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x1000;
-
+	
 	.data : {
 		*(.data);
 	} :data
+	
 	.tdata : {
 		_tdata_start = .;
@@ -31,16 +34,27 @@
 		_tbss_end = .;
 	} :data
+	
 	_tls_alignment = ALIGNOF(.tdata);
+	
 	.bss : {
 		*(COMMON);
 		*(.bss);
 	} :data
-
-	. = ALIGN(0x1000);
-	_heap = .;
+	
+#ifdef CONFIG_LINE_DEBUG
+	.comment 0 : { *(.comment); } :debug
+	.debug_abbrev 0 : { *(.debug_abbrev); } :debug
+	.debug_aranges 0 : { *(.debug_aranges); } :debug
+	.debug_info 0 : { *(.debug_info); } :debug
+	.debug_line 0 : { *(.debug_line); } :debug
+	.debug_loc 0 : { *(.debug_loc); } :debug
+	.debug_pubnames 0 : { *(.debug_pubnames); } :debug
+	.debug_pubtypes 0 : { *(.debug_pubtypes); } :debug
+	.debug_ranges 0 : { *(.debug_ranges); } :debug
+	.debug_str 0 : { *(.debug_str); } :debug
+#endif
 	
 	/DISCARD/ : {
 		*(*);
 	}
-
 }
Index: uspace/lib/c/arch/amd64/src/entry.s
===================================================================
--- uspace/lib/c/arch/amd64/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/amd64/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -47,4 +47,2 @@
 	# Pass PCB pointer to __main (no operation)
 	call __main
-
-	call __exit
Index: uspace/lib/c/arch/arm32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/arm32/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/arm32/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -9,15 +9,16 @@
 SECTIONS {
 	. = 0x1000 + SIZEOF_HEADERS;
-
+	
 	.init : {
 		*(.init);
-	} : text
+	} :text
+	
 	.text : {
 		*(.text);
-        *(.rodata*);
+		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x1000;
-
+	
 	.data : {
 		*(.opd);
@@ -25,4 +26,5 @@
 		*(.sdata);
 	} :data
+	
 	.tdata : {
 		_tdata_start = .;
@@ -33,18 +35,16 @@
 		_tbss_end = .;
 	} :data
+	
 	_tls_alignment = ALIGNOF(.tdata);
+	
 	.bss : {
 		*(.sbss);
 		*(.scommon);
-        *(COMMON);
-        *(.bss);
+		*(COMMON);
+		*(.bss);
 	} :data
-	
-	. = ALIGN(0x1000);
-	_heap = .;
 	
 	/DISCARD/ : {
 		*(*);
 	}
-
 }
Index: uspace/lib/c/arch/arm32/src/entry.s
===================================================================
--- uspace/lib/c/arch/arm32/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/arm32/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -42,5 +42,5 @@
 	ldr r0, =ras_page
 	str r2, [r0]
-
+	
 	#
 	# Create the first stack frame.
@@ -50,10 +50,8 @@
 	push {fp, ip, lr, pc}
 	sub fp, ip, #4
-
+	
 	# Pass pcb_ptr to __main as the first argument (in r0)
 	mov r0, r1
 	bl __main
-
-	bl __exit
 
 .data
@@ -62,3 +60,2 @@
 ras_page:
 	.long 0
-
Index: uspace/lib/c/arch/ia32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ia32/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ia32/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -5,4 +5,5 @@
 	text PT_LOAD FLAGS(5);
 	data PT_LOAD FLAGS(6);
+	debug PT_NOTE;
 }
 
@@ -42,7 +43,16 @@
 	} :data
 	
-	. = ALIGN(0x1000);
-	
-	_heap = .;
+#ifdef CONFIG_LINE_DEBUG
+	.comment 0 : { *(.comment); } :debug
+	.debug_abbrev 0 : { *(.debug_abbrev); } :debug
+	.debug_aranges 0 : { *(.debug_aranges); } :debug
+	.debug_info 0 : { *(.debug_info); } :debug
+	.debug_line 0 : { *(.debug_line); } :debug
+	.debug_loc 0 : { *(.debug_loc); } :debug
+	.debug_pubnames 0 : { *(.debug_pubnames); } :debug
+	.debug_pubtypes 0 : { *(.debug_pubtypes); } :debug
+	.debug_ranges 0 : { *(.debug_ranges); } :debug
+	.debug_str 0 : { *(.debug_str); } :debug
+#endif
 	
 	/DISCARD/ : {
Index: uspace/lib/c/arch/ia32/src/entry.s
===================================================================
--- uspace/lib/c/arch/ia32/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ia32/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -46,5 +46,5 @@
 	mov %ax, %fs
 	# Do not set %gs, it contains descriptor that can see TLS
-
+	
 	# Detect the mechanism used for making syscalls
 	movl $(INTEL_CPUID_STANDARD), %eax
@@ -58,10 +58,8 @@
 	# Create the first stack frame.
 	#
-	pushl $0 
+	pushl $0
 	movl %esp, %ebp
-
+	
 	# Pass the PCB pointer to __main as the first argument
 	pushl %edi
 	call __main
-
-	call __exit
Index: uspace/lib/c/arch/ia64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ia64/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ia64/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -9,19 +9,21 @@
 SECTIONS {
 	. = 0x4000 + SIZEOF_HEADERS;
-
+	
 	.init : {
 		*(.init);
-	} : text
+	} :text
+	
 	.text : {
 		*(.text);
 		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x4000;
-
+	
 	.got : {
 		_gp = .;
 		*(.got*);
-	} :data	
+	} :data
+	
 	.data : {
 		*(.opd);
@@ -29,4 +31,5 @@
 		*(.sdata);
 	} :data
+	
 	.tdata : {
 		_tdata_start = .;
@@ -37,5 +40,7 @@
 		_tbss_end = .;
 	} :data
+	
 	_tls_alignment = ALIGNOF(.tdata);
+	
 	.bss : {
 		*(.sbss);
@@ -44,10 +49,7 @@
 		*(.bss);
 	} :data
-
-	. = ALIGN(0x4000);
-	_heap = .;
- 
+	
 	/DISCARD/ : {
 		*(*);
-        }
+	}
 }
Index: uspace/lib/c/arch/ia64/src/entry.s
===================================================================
--- uspace/lib/c/arch/ia64/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ia64/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -40,8 +40,6 @@
 	alloc loc0 = ar.pfs, 0, 1, 2, 0
 	movl gp = _gp
-
+	
 	# Pass PCB pointer as the first argument to __main
 	mov out0 = r2
 	br.call.sptk.many b0 = __main
-0:
-	br.call.sptk.many b0 = __exit
Index: uspace/lib/c/arch/mips32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/mips32/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/mips32/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -13,43 +13,46 @@
 		*(.init);
 	} :text
+	
 	.text : {
-	        *(.text);
+		*(.text);
 		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x4000;
-
+	
 	.data : {
 		*(.data);
 		*(.data.rel*);
 	} :data
-
+	
 	.got : {
 		_gp = .;
 		*(.got);
 	} :data
-
+	
 	.tdata : {
 		_tdata_start = .;
 		*(.tdata);
 		_tdata_end = .;
+	} :data
+	
+	.tbss : {
 		_tbss_start = .;
 		*(.tbss);
 		_tbss_end = .;
 	} :data
-	_tls_alignment = ALIGNOF(.tdata);
-
+	
+	_tls_alignment = MAX(ALIGNOF(.tdata), ALIGNOF(.tbss));
+	
 	.sbss : {
 		*(.scommon);
 		*(.sbss);
-	}	
+	}
+	
 	.bss : {
 		*(.bss);
 		*(COMMON);
 	} :data
-
-	. = ALIGN(0x4000);
-	_heap = .;
-
+	
 	/DISCARD/ : {
 		*(*);
Index: uspace/lib/c/arch/mips32/src/entry.s
===================================================================
--- uspace/lib/c/arch/mips32/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/mips32/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -29,6 +29,7 @@
 .text
 .section .init, "ax"
+
 .global __entry
-.global __entry_driver
+
 .set noreorder
 .option pic2
@@ -56,10 +57,3 @@
 	jal __main
 	nop
-	
-	jal __exit
-	nop
 .end
-
-# Alignment of output section data to 0x4000
-.section .data
-.align 14
Index: uspace/lib/c/arch/ppc32/_link.ld.in
===================================================================
--- uspace/lib/c/arch/ppc32/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ppc32/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -9,19 +9,21 @@
 SECTIONS {
 	. = 0x1000 + SIZEOF_HEADERS;
-
+	
 	.init : {
 		*(.init);
 	} :text
+	
 	.text : {
 		*(.text);
 		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x1000;
-
+	
 	.data : {
 		*(.data);
 		*(.sdata);
 	} :data
+	
 	.tdata : {
 		_tdata_start = .;
@@ -32,5 +34,7 @@
 		_tbss_end = .;
 	} :data
+	
 	_tls_alignment = ALIGNOF(.tdata);
+	
 	.bss : {
 		*(.sbss);
@@ -38,11 +42,7 @@
 		*(.bss);
 	} :data
-
-	. = ALIGN(0x1000);
-	_heap = .;
 	
 	/DISCARD/ : {
 		*(*);
 	}
-
 }
Index: uspace/lib/c/arch/ppc32/src/entry.s
===================================================================
--- uspace/lib/c/arch/ppc32/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/ppc32/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -44,9 +44,7 @@
 	stw %r3, 0(%r1)
 	stwu %r1, -16(%r1)
-
+	
 	# Pass the PCB pointer to __main() as the first argument.
 	# The first argument is passed in r3.
 	mr %r3, %r6
 	bl __main
-
-	bl __exit
Index: uspace/lib/c/arch/sparc64/_link.ld.in
===================================================================
--- uspace/lib/c/arch/sparc64/_link.ld.in	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/sparc64/_link.ld.in	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -9,23 +9,26 @@
 SECTIONS {
 	. = 0x4000 + SIZEOF_HEADERS;
-
+	
 	.init : {
 		*(.init);
 	} :text
+	
 	.text : {
 		*(.text);
 		*(.rodata*);
 	} :text
-
+	
 	. = . + 0x4000;
-
+	
 	.got : {
 		 _gp = .;
 		 *(.got*);
 	} :data
+	
 	.data : {
 		*(.data);
 		*(.sdata);
 	} :data
+	
 	.tdata : {
 		_tdata_start = .;
@@ -36,5 +39,7 @@
 		_tbss_end = .;
 	} :data
+	
 	_tls_alignment = ALIGNOF(.tdata);
+	
 	.bss : {
 		*(.sbss);
@@ -42,11 +47,7 @@
 		*(.bss);
 	} :data
-
-	. = ALIGN(0x4000);
-	_heap = .;
 	
 	/DISCARD/ : {
 		*(*);
 	}
-
 }
Index: uspace/lib/c/arch/sparc64/src/entry.s
===================================================================
--- uspace/lib/c/arch/sparc64/src/entry.s	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/arch/sparc64/src/entry.s	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -45,5 +45,5 @@
 	flushw
 	add %g0, -0x7ff, %fp
-
+	
 	# Pass pcb_ptr as the first argument to __main()
 	mov %i1, %o0
@@ -51,5 +51,2 @@
 	call __main
 	or %l7, %lo(_gp), %l7
-
-	call __exit
-	nop
Index: uspace/lib/c/generic/as.c
===================================================================
--- uspace/lib/c/generic/as.c	(revision 976f5467374c4083883e264c4bac5dc6e98c2a1c)
+++ uspace/lib/c/generic/as.c	(revision 19a18004a56ed89f716b2310c889ca6b22618bbd)
@@ -35,4 +35,5 @@
 #include <as.h>
 #include <libc.h>
+#include <errno.h>
 #include <unistd.h>
 #include <align.h>
@@ -40,7 +41,5 @@
 #include <bitops.h>
 #include <malloc.h>
-
-/** Last position allocated by as_get_mappable_page */
-static uintptr_t last_allocated = 0;
+#include "private/libc.h"
 
 /** Create address space area.
@@ -103,27 +102,41 @@
 }
 
-/** Return pointer to some unmapped area, where fits new as_area
+/** Return pointer to unmapped address space area
  *
  * @param size Requested size of the allocation.
  *
- * @return pointer to the beginning
+ * @return Pointer to the beginning of unmapped address space area.
  *
  */
 void *as_get_mappable_page(size_t size)
 {
-	if (size == 0)
-		return NULL;
+	return (void *) __SYSCALL2(SYS_AS_GET_UNMAPPED_AREA,
+	    (sysarg_t) __entry, (sysarg_t) size);
+}
+
+/** Find mapping to physical address.
+ *
+ * @param address Virtual address in question (virtual).
+ * @param[out] frame Frame address (physical).
+ * @return Error code.
+ * @retval EOK No error, @p frame holds the translation.
+ * @retval ENOENT Mapping not found.
+ */
+int as_get_physical_mapping(void *address, uintptr_t *frame)
+{
+	uintptr_t tmp_frame;
+	uintptr_t virt = (uintptr_t) address;
 	
-	size_t sz = 1 << (fnzb(size - 1) + 1);
-	if (last_allocated == 0)
-		last_allocated = get_max_heap_addr();
+	int rc = (int) __SYSCALL2(SYS_PAGE_FIND_MAPPING,
+	    (sysarg_t) virt, (sysarg_t) &tmp_frame);
+	if (rc != EOK) {
+		return rc;
+	}
 	
-	/*
-	 * Make sure we allocate from naturally aligned address.
-	 */
-	uintptr_t res = ALIGN_UP(last_allocated, sz);
-	last_allocated = res + ALIGN_UP(size, PAGE_SIZE);
+	if (frame != NULL) {
+		*frame = tmp_frame;
+	}
 	
-	return ((void *) res);
+	return EOK;
 }
 
